'use strict';

bsApp.controller('bsController', function ($scope, $interval, $timeout, bsMessagePort, udpSocket, udpSender, udpUtils, growl) {
//bsApp.controller('bsController', function ($scope, bsMessagePort, udpSocket, udpSender, udpUtils, ticker, tickerParams, $timeout) {
    $scope.playerDeviceInfo = {};
    $scope.listOfPlayers = [];
    $scope.rowsAndColumns = {
        layout: {
            rows: 1,
            columns: 1
        }
    };
    $scope.screenResY = 1080;
    $scope.screenResX = 1920;
    $scope.xTrans = 0;
    $scope.yTrans = 0;
    $scope.currentPlaylist = [];
    $scope.nextPlaylist = [];
    $scope.nextPlaylistString = "";
    $scope.switcher = 0;
    $scope.resetSwitcher = false;

    $scope.scaleFactor = 1;
    $scope.globalTicker = null;
    $scope.ticker = null;
    //$scope.totalWallResX = $scope.screenResX;
    //$scope.totalWallResY = $scope.screenResY;
    $scope.bezelXPixels = 0;
    $scope.bezelYPixels = 0;
    $scope.numberOfCheckins = 0;

    $scope.udpMessage = "-no message yet-";
    $scope.doSendUdp = function (message) {
        //console.log("sender: message=" + message);
        udpSender.sendToIp("255.255.255.255", $scope.playerDeviceInfo.udpPort, message);
    };

    $scope.sendUdpToIp = function (ip, port, message){
        //console.log("sender: message=" + message);
        udpSender.sendToIp(ip, port, message);
    };
    $scope.bsMessage = "emptymessage";
    bsMessagePort.onbsmessage = function(msg){
        //ismaster Signifies the first BSMessage, it's a key in the data AA, not a boolean
        if(msg.data.ismaster) {
            console.log("BSMessagePort: ismaster");
            console.log(msg.data);
            $scope.playerDeviceInfo = msg.data;
            $scope.playerDeviceInfo.udpPort =       parseInt($scope.playerDeviceInfo.ptpdomain) + 5000;
            udpSender.BindLocalPort($scope.playerDeviceInfo.udpPort);
            /* Sync Section */
            $scope.sync = new BSSyncManager(("autowall"+$scope.playerDeviceInfo.udpPort), "224.0.126.10", $scope.playerDeviceInfo.udpPort+1);
            $scope.sync.onsyncevent = function(e){
                //console.log("SYNC event received");
                //console.log(e);
                $scope.switcher = parseInt((e.id));
                $scope.e_iso_timestamp = e.iso_timestamp;
                $scope.e_domain = e.domain;
                if($scope.currentPlaylist.length > 0) {
                    $scope.playNextVideo();
                }
            };

            //recast strings to Ints
            $scope.playerDeviceInfo.bezelwidth =    parseInt($scope.playerDeviceInfo.bezelwidth);
            $scope.playerDeviceInfo.bezelheight =   parseInt($scope.playerDeviceInfo.bezelheight);
            $scope.playerDeviceInfo.screenwidth =   parseInt($scope.playerDeviceInfo.screenwidth);
            $scope.playerDeviceInfo.screenheight =  parseInt($scope.playerDeviceInfo.screenheight);
            $scope.playerDeviceInfo.bezelCompIsOn = ($scope.playerDeviceInfo.bezelwidth > 0
                                                  && $scope.playerDeviceInfo.bezelheight  > 0
                                                  && $scope.playerDeviceInfo.screenwidth  > 0
                                                  && $scope.playerDeviceInfo.screenheight > 0);
            if (meetsRequiredNamingConvention(msg.data.devicename)) {
                $scope.playerDeviceInfo.row = numberOfRowsFromName($scope.playerDeviceInfo.devicename);
                $scope.playerDeviceInfo.column = numberOfColumnsFromName($scope.playerDeviceInfo.devicename);
            } else {
                addPlayerNameDoesNotMeetNamingConventionMessage();
            }
            if ($scope.playerDeviceInfo.ismaster == true) {
                $scope.isMaster = true;
                console.log("I am the master");
                $scope.sync.SetMaster(1);
                requestCheckIns();
                $interval(checkForMissingPlayers, 5000);
                $interval(otherMasterErrorCheck, 5000);
            } else {
                if($scope.playerDeviceInfo.ipaddress) {
                    sendCheckInObject();
                }
                $scope.playerDeviceInfo.lastMasterContact = Date.now();
                $interval(cannotContactMasterCheck, 5000);
            }
            console.log($scope.playerDeviceInfo);
        }else if (msg.data.networkattached){
            $scope.playerDeviceInfo.ipaddress = msg.data.ipaddress;
        }else if (msg.data.networkdetached){
            $scope.playerDeviceInfo.ipaddress = 0;
        }else if (msg.data.feedname){
            var myData = decodeURIComponent(escape(window.atob(msg.data.base64)));
            if (msg.data.feedname === "ticker"){
                console.log("A ticker feed has been updated");
                console.log(myData);
                var localTickerData = (localStorage.getItem("tickerFeed"));
                if (localTickerData !== myData) {
                    console.log("New ticker feed being defined based on changes in host feed");
                    localStorage.setItem("tickerFeed", myData);
                    $scope.tickerFeed = JSON.parse(myData);
                    if($scope.ticker) {
                        if ($scope.ticker.GetRightmost()) {
                            $scope.ticker.PopAllStrings();
                            for (var j = 0; j < $scope.tickerFeed.length; j++) {
                                $scope.ticker.AddString($scope.tickerFeed[j]);
                            }
                        }
                    }
                }
            }else {
                console.log("A feed has been updated");
                console.log(myData);

                var localData = (localStorage.getItem("feed"));
                if (localData !== myData) {
                    $scope.nextPlaylist.length = 0;  //reset playlist array - empty it
                    console.log("New Playlist being defined based on changes in host feed");
                    localStorage.setItem("feed", myData);

                    var obj = JSON.parse(myData);
                    for (var i = 0; i < obj.length; i++) {
                        var playlistItem = obj[i];
                        //Only push if it's a video
                        if (~playlistItem.type.indexOf("video")) {
                            $scope.nextPlaylist.push(playlistItem.url);
                        }
                    }
                    // Check to see if feed data is different from local stored data. If they are the same just keep playing the playlist
                    // If the feed data is different from the local data then update the playlist array and play new playlist
                    $scope.nextPlaylistString = JSON.stringify($scope.nextPlaylist);
                    console.log("Next playlist:");

                    console.log($scope.nextPlaylist);
                    if ($scope.isMaster) {
                        determineWhetherAllPlayersAreReadyForTransition();
                    } else {
                        checkWhetherMissedTransition($scope.nextPlaylistString);
                    }

                    //This is the first load of MRSS, need to kick off sync
                    if (!localData) {
                        $scope.currentPlaylist = $scope.nextPlaylist.slice(0);
                        if ($scope.isMaster) {
                            $scope.sendVideoSync();
                        } else {
                            //$scope.playNextVideo();
                        }
                    }
                }
            }
        }
    };

    function determineWhetherAllPlayersAreReadyForTransition(){
        var notReady = false;
        for(var i = 0; i < $scope.listOfPlayers.length; i++){
            console.log("Player already in list");
            //The master doesn't send out it's playlist over UDP, so set it in the player list here.
            if($scope.listOfPlayers[i].deviceName == "a-1"){
                $scope.listOfPlayers[i].nextPlaylistString = $scope.nextPlaylistString;
            }
            if($scope.listOfPlayers[i].nextPlaylistString != $scope.nextPlaylistString){
                //console.log("nextPlaylistStrings don't match",$scope.listOfPlayers[i].nextPlaylistString, $scope.listOfPlayers[i].deviceName, $scope.nextPlaylistString);
                //console.log($scope.listOfPlayers);
                notReady = true;
            }
        }
        if(notReady){
            console.log("Not ready for transistion.");
            requestNextPlaylistStrings();
            $timeout(determineWhetherAllPlayersAreReadyForTransition, 5000);
        }else{
            beginTransition();
        }
    }

    function checkWhetherMissedTransition(playlistString){
        var request = {
            missedTransitionCheck : true,
            newPlaylist : playlistString
        };
        $scope.doSendUdp(JSON.stringify(request));
    }

    function requestNextPlaylistStrings(){
        var request = {needNextPlaylistString : "true"};
        $scope.doSendUdp(JSON.stringify(request));
    }

    function sendNextPlaylistString(){
        console.log("sendNextPlaylistString: ");
        var udpJSON = {
            nextPlaylistString : $scope.nextPlaylistString,
            deviceName : $scope.playerDeviceInfo.devicename
        };
        console.log(udpJSON);
        $scope.doSendUdp(JSON.stringify(udpJSON));
    }

    function beginTransition(){
        console.log("Begin transition.");
        var request = {beginTransition:"true"};
        $scope.doSendUdp(JSON.stringify(request));
    }

    udpSocket.ondatagram = function (e) {
        $scope.$apply(function () {
            var bytes = e.getBytes();
            $scope.udpMessage = udpUtils.bytesToString(bytes);
            try {
                //console.log(JSON.parse($scope.udpMessage));
                //console.log("receiver: message=" + $scope.udpMessage);
                var udpPayloadObject = JSON.parse($scope.udpMessage);
                if (udpPayloadObject.hasOwnProperty('checkingIn') && $scope.isMaster) {
                    if (udpPayloadObject.hasOwnProperty('ipAddress')) {
                        if(udpPayloadObject.numberOfCheckins == 1){
                            notifyTickerOfPlayerChange();
                        }
                        addPlayerIfNew(udpPayloadObject);
                        sendLayout();
                    }
                } else if (udpPayloadObject.hasOwnProperty('pleaseCheckIn')) {
                    $scope.playerDeviceInfo.lastMasterContact = Date.now();
                    if($scope.playerDeviceInfo.ipaddress) {
                        sendCheckInObject();
                    }
                } else if (udpPayloadObject.hasOwnProperty('layout')) {
                    $scope.rowsAndColumns.layout = udpPayloadObject.layout;
                }else if (udpPayloadObject.hasOwnProperty("needNextPlaylistString") && !$scope.isMaster){
                    console.log("received request for playlist String");
                    sendNextPlaylistString();
                }else if (udpPayloadObject.hasOwnProperty("nextPlaylistString") && $scope.isMaster){
                    for(var i = 0; i < $scope.listOfPlayers.length; i++){
                        console.log("udpPayloadObject.deviceName: " + udpPayloadObject.deviceName);
                        console.log("$scope.listOfPlayers[i].deviceName: " + $scope.listOfPlayers[i].deviceName);
                        console.log("udpPayloadObject.nextPlaylistString: " + udpPayloadObject.nextPlaylistString);
                        if(udpPayloadObject.deviceName == $scope.listOfPlayers[i].deviceName){
                            $scope.listOfPlayers[i].nextPlaylistString = udpPayloadObject.nextPlaylistString;
                        }
                    }
                }else if (udpPayloadObject.hasOwnProperty("beginTransition")){
                    //copy the new playlist
                    $scope.currentPlaylist = $scope.nextPlaylist.slice(0);
                    $scope.resetSwitcher = true;
                }else if (udpPayloadObject.hasOwnProperty("missedTransitionCheck") && $scope.isMaster){
                    //The slave player updated its MRSS late, was likely off during the transition
                    console.log("Missed Transition Check: ");
                    console.log(udpPayloadObject.newPlaylist);
                    console.log(JSON.stringify($scope.currentPlaylist));
                    if (udpPayloadObject.newPlaylist == JSON.stringify($scope.currentPlaylist)){
                        beginTransition();
                    }
                }else if (udpPayloadObject.hasOwnProperty("rightmost")){
                    console.log("Multiscreen ticker, local params:");
                    console.log(udpPayloadObject);
                    if ($scope.playerDeviceInfo.monitororientation != "landscape"){
                        $scope.newTicker($scope.globalTicker.color, $scope.globalTicker.backgroundColor,
                            $scope.globalTicker.speed, udpPayloadObject.y, udpPayloadObject.x, udpPayloadObject.h,
                            udpPayloadObject.w, udpPayloadObject.rightmost, udpPayloadObject.offset, udpPayloadObject.scaledTickerWidth, true);
                    }else{
                        $scope.newTicker($scope.globalTicker.color, $scope.globalTicker.backgroundColor,
                            $scope.globalTicker.speed, udpPayloadObject.x, udpPayloadObject.y, udpPayloadObject.w,
                            udpPayloadObject.h, udpPayloadObject.rightmost, udpPayloadObject.offset, udpPayloadObject.scaledTickerWidth, false);
                    }
                                    }else if(udpPayloadObject.hasOwnProperty("shutdownTicker")){
                    console.log("Shutdown ticker");
                    if ($scope.ticker){
                        console.log("Ticker exists. Shutting down.");
                        $scope.ticker.Shutdown();
                    }
                }else if (udpPayloadObject.hasOwnProperty("masterErrorCheck")){
                    if($scope.isMaster){
                        if(udpPayloadObject.masterErrorCheck != $scope.playerDeviceInfo.ipaddress){
                            console.log("There are two player's named 'A-1' using the same ptp_domain");
                            $scope.ptpConflictErrorMessage();
                        }
                    }
                }
            }catch (err){
                //Probably not JSON coming in.
                //console.log(err.message);
            }
        });
    };

    function addPlayerIfNew(slavePlayer){
        //console.log("addPlayerIfNew():");
        //console.log(slavePlayer);
        for (var i = 0, len = $scope.listOfPlayers.length; i < len; i++) {
            if ($scope.listOfPlayers[i].deviceName == slavePlayer.deviceName){
                $scope.listOfPlayers[i].lastCheckInTime = Date.now();
                return;
            }
        }
        slavePlayer.lastCheckInTime = Date.now();
        $scope.listOfPlayers.push(slavePlayer);
        notifyTickerOfPlayerChange();

        //console.log("Player added to list");
        //console.log("List of players: ");
        //console.log($scope.listOfPlayers);
        var row    = numberOfRowsFromName(slavePlayer.deviceName);
        var column = numberOfColumnsFromName(slavePlayer.deviceName);
        if (row > $scope.rowsAndColumns.layout.rows) {
            $scope.rowsAndColumns.layout.rows = row;
        }
        if (column > $scope.rowsAndColumns.layout.columns) {
            $scope.rowsAndColumns.layout.columns = column;
        }
    }

    function numberOfRowsFromName(name){
        return name.charCodeAt(0) - 96;
    }

    function numberOfColumnsFromName(name){
        return parseInt(name.substring(2, name.length));
    }

    function sendLayout() {
        //console.log(JSON.stringify($scope.rowsAndColumns));
        $scope.doSendUdp(JSON.stringify($scope.rowsAndColumns));
    }

    function requestCheckIns(){
        var requestCheckIns = {
            pleaseCheckIn : true
        };
        $scope.doSendUdp(JSON.stringify(requestCheckIns));
    }

    function checkForMissingPlayers(){
        var playerRemoved = false;
        for (var i = 0; i < $scope.listOfPlayers.length; i++) {
            //console.log($scope.listOfPlayers[i]);
            if (Date.now() - $scope.listOfPlayers[i].lastCheckInTime > 10000){
                playerRemoved = true;
                $scope.listOfPlayers.splice(i, 1);
                //item removed so we need to do this index again
                i--;
            }
        }
        if(playerRemoved){
            notifyTickerOfPlayerChange();
            adjustLayout();
        }
        tickerStateMachine();
        requestCheckIns();
    }

    function adjustLayout(){
        var maxColumn = 1;
        var maxRow = 1;
        var row;
        var column;
        for (var i = 0, len = $scope.listOfPlayers.length; i < len; i++) {
            row    = numberOfRowsFromName($scope.listOfPlayers[i].deviceName);
            column = numberOfColumnsFromName($scope.listOfPlayers[i].deviceName);
            maxColumn = column > maxColumn ? column : maxColumn;
            maxRow    = row    > maxRow    ? row    : maxRow;
        }
        $scope.rowsAndColumns.layout.columns = maxColumn;
        $scope.rowsAndColumns.layout.rows = maxRow;
    }

    function sendCheckInObject() {
        $scope.numberOfCheckins++;
        var checkingInStringObject = {
            checkingIn : true,
            ipAddress  : $scope.playerDeviceInfo.ipaddress,
            deviceName : $scope.playerDeviceInfo.devicename,
            numberOfCheckins: $scope.numberOfCheckins
        };
        $scope.doSendUdp(JSON.stringify(checkingInStringObject));
    }

    $scope.setTransformStyle = function(){
        var rows = $scope.rowsAndColumns.layout.rows;
        var columns = $scope.rowsAndColumns.layout.columns;


        var numberOfScreens =   rows >= columns ? rows : columns;
        $scope.xScaleFactor = numberOfScreens;

        $scope.yScaleFactor = numberOfScreens;

        //console.log("bezelCompIsOn: "+$scope.playerDeviceInfo.bezelCompIsOn);
        if($scope.playerDeviceInfo.bezelCompIsOn){
            //Width Calculations
            var screenResX =  $scope.screenResX;
            var screenWidth = $scope.playerDeviceInfo.screenwidth;
            var bezelWidth =  $scope.playerDeviceInfo.bezelwidth;

            var numberOfBezels = numberOfScreens - 1;
            var xScaleFactor = (numberOfScreens * screenWidth + numberOfBezels * bezelWidth)/screenWidth;
            var totalXPixels = parseInt(xScaleFactor * screenResX);
            var bezelXPixels = 0;
            if(numberOfBezels > 0) {
                bezelXPixels = parseInt((totalXPixels - screenResX * numberOfScreens) / numberOfBezels);
            }

/*
            console.log("xScaleFactor: "+ xScaleFactor);
            console.log("totalXPixels: "+ totalXPixels);
            console.log("bezelXPixels: "+ bezelXPixels);
*/
            //Height Calculations
            var screenResY =  $scope.screenResY;
            var screenHeight = $scope.playerDeviceInfo.screenheight;

            var bezelHeight =  $scope.playerDeviceInfo.bezelheight;
            var yScaleFactor = (numberOfScreens * screenHeight + numberOfBezels * bezelHeight)/screenHeight;
            var totalYPixels = parseInt(yScaleFactor * screenResY);
            var bezelYPixels = 0;
            if (numberOfBezels > 0) {
                //console.log(ret);
                bezelYPixels = parseInt((totalYPixels - screenResY * numberOfScreens) / numberOfBezels);
            }
            /*
            console.log("------------------------");
            console.log("yScaleFactor: "+ yScaleFactor);
            console.log("totalYPixels: "+ totalYPixels);
            console.log("bezelYPixels: "+ bezelYPixels);
            */

            $scope.xScaleFactor = xScaleFactor;
            $scope.yScaleFactor = yScaleFactor;
            $scope.bezelXPixels = bezelXPixels;

            $scope.bezelYPixels = bezelYPixels;
        }
        //matrix(scaleX(),skewY(),skewX(),scaleY(),translateX(),translateY()):
        if ($scope.playerDeviceInfo.monitororientation == 'portrait') {
            return {
                transform: 'matrix(' +
                $scope.yScaleFactor + ',0,0,' +
                $scope.xScaleFactor + ',' +
                -1*getYTrans() + ',' + getXTrans() + ')',
                'transform-origin': 'right top'
            };
        }else {
            return {
                transform: 'matrix(' +
                $scope.xScaleFactor + ',0,0,' +
                $scope.yScaleFactor + ',' +
                getXTrans() + ',' + getYTrans() + ')',
                'transform-origin': 'left top'//ternary for monitor orientation
            };
        }
    };

    function getXTrans(){
        var columnIndex =  $scope.playerDeviceInfo.column - 1;
        return -1 * ($scope.screenResX  + $scope.bezelXPixels) * columnIndex;
    }
    function getYTrans(){
        var rowIndex =  $scope.playerDeviceInfo.row - 1;
        return -1 * ($scope.screenResY + $scope.bezelYPixels) * rowIndex;
    }

    /*/!* Sync Section *!/
    $scope.sync = new BSSyncManager("brightsign", "224.0.126.10", 5439);
    $scope.sync.onsyncevent = function(e){
        console.log("SYNC event received");
        console.log(e);
        $scope.switcher = parseInt((e.id));
        $scope.e_iso_timestamp = e.iso_timestamp;
        $scope.e_domain = e.domain;
        if($scope.currentPlaylist.length > 0) {
            $scope.playNextVideo();
        }
    };*/

    $scope.loadFromMemory = function(){
        //When first boot occurs load playlist from memory in case there is no network connection
        console.log("INITIALIZE: loading from memory");
        var localData = (localStorage.getItem("feed"));
        if (localData) {
            var obj = JSON.parse(localData);
            for (var i = 0; i < obj.length; i++) {
                var playlistItem = obj[i];
                //Only push the item if it's video
                if(~playlistItem.type.indexOf("video")) {
                    $scope.currentPlaylist.push(playlistItem.url);
                }
            }
            //Set next playlist to current, for the playlist transition check
            $scope.nextPlaylist = $scope.currentPlaylist.slice(0);
            $scope.nextPlaylistString = JSON.stringify($scope.nextPlaylist);
            console.log($scope.currentPlaylist);
            $scope.sendSyncIfMaster();
         }
    };
    $scope.chooseNextVideo = function () {
        if($scope.resetSwitcher){
            $scope.switcher = 0;
            $scope.resetSwitcher = false;
        }else{
            //console.log("Math test: "+$scope.switcher+ " "+$scope.currentPlaylist.length + " "+ (($scope.switcher + 1) % $scope.currentPlaylist.length));
            $scope.switcher = ($scope.switcher + 1) % $scope.currentPlaylist.length;
        }
    };

    $scope.sendSyncIfMaster = function() {
        //console.log("Send sync if master: "+$scope.isMaster );
        if($scope.playerDeviceInfo.ipaddress) {
            if ($scope.isMaster) {
                $scope.sendVideoSync();
            }
        }else{
            console.log("Initial BSMessagePort hasn't come in yet. Retry in one second");
            $timeout($scope.sendSyncIfMaster, 1000);
        }
    };
    // Only called by the master
    $scope.sendVideoSync = function () {
        //console.log("Sending synchronize, scope.switcher:" + $scope.switcher);
        $scope.sync.Synchronize($scope.switcher, 200);
    };
    $scope.playNextVideo = function () {
        if ($scope.player) {
            //console.log("Play next file: "+ $scope.currentPlaylist[$scope.switcher] + " " + $scope.switcher);
            $scope.removeLoadingMessage();
            if ($scope.playerDeviceInfo.model == "LS423"){
                $scope.player.setAttribute("hwz","z-index:-1;viewmode:scale-to-fill;rot90.50"); //TODO ternary for monitor orientation
            }else{
                $scope.player.setAttribute("hwz","z-index:-1;viewmode:scale-to-fill;rot270"); //TODO ternary for monitor orientation
            }

            $scope.player.setSyncParams($scope.e_domain,$scope.switcher,$scope.e_iso_timestamp);
            $scope.player.src = $scope.currentPlaylist[$scope.switcher];
            $scope.player.load();
            $scope.player.play();
        }
    };

    $scope.setHWZToBack = function(){
        if ($scope.player) {
            if ($scope.playerDeviceInfo.model == "LS423"){
                $scope.player.setAttribute("hwz","z-index:-1;viewmode:scale-to-fill;rot90.50"); //TODO ternary for monitor orientation
            }else{
                $scope.player.setAttribute("hwz","z-index:-1;viewmode:scale-to-fill;rot270"); //TODO ternary for monitor orientation
            }
            //$scope.player.setAttribute("hwz","z-index:-1;viewmode:scale-to-fill;rot270"); //TODO ternary for monitor orientation
        }
    };

    /*
    * bsTicker Controller section
    *
    */
    //runs on the master to handle the state of all tickers
    function tickerStateMachine(){
        //console.log("tickerStateMachine executed");
        //is there a ticker in the html?
        if($scope.globalTicker){
            //console.log("globalTicker exists");
            if($scope.globalTicker){
                //this Boolean is set to true by checkForMissingPlayers() or addPlayerIfNew()
                if($scope.globalTicker.slavesHaveBeenAddedOrRemoved){
                    determineTickerLayout();
                    $scope.globalTicker.slavesHaveBeenAddedOrRemoved = false;
                }
            }
        }else{
            //console.log("no ticker exists");
        }
    }

    function notifyTickerOfPlayerChange(){
        if($scope.globalTicker){
            $scope.globalTicker.slavesHaveBeenAddedOrRemoved = true;
        }
        console.log("Player change has occurred");
    }

    function determineTickerLayout(){
        console.log("determining ticker layout");
        var totalColumns = $scope.rowsAndColumns.layout.columns;
        var totalRows = $scope.rowsAndColumns.layout.rows;

        //var totalXPixels = totalColumns * $scope.screenResX;
        //var totalYPixels = totalRows    * $scope.screenResY;

        var scalar = totalRows > totalColumns ? totalRows : totalColumns;
        var scaledTickerX = $scope.globalTicker.x * scalar;
        var scaledTickerY = $scope.globalTicker.y * scalar;
        var scaledTickerW = $scope.globalTicker.width * scalar;
        var scaledTickerH = $scope.globalTicker.height * scalar;

        var xOriginOfScreen;
        var yOriginOfScreen;
        var playersWithTickerOnScreen = [];
        var rightMostTicker = "a-1";
        //Clear all screens' tickers
        var shutdownCommand = {shutdownTicker:true};
        $scope.doSendUdp(JSON.stringify(shutdownCommand));
        var screenResX = ($scope.playerDeviceInfo.monitororientation == "landscape")? $scope.screenResX:$scope.screenResY;
        var screenResY = ($scope.playerDeviceInfo.monitororientation == "landscape")? $scope.screenResY:$scope.screenResX;
        for (var i = 0, len = $scope.listOfPlayers.length; i < len; i++) {
            var player = $scope.listOfPlayers[i];
            //Clear out old layout data
            player.localTickerParams = null;
            console.log("Player: ", player.deviceName);
            console.log(player);
            if($scope.playerDeviceInfo.monitororientation == "landscape"){
                xOriginOfScreen = (numberOfColumnsFromName(player.deviceName)- 1) * screenResX;
                yOriginOfScreen = (numberOfRowsFromName(player.deviceName)- 1) * screenResY;
            }else{
                xOriginOfScreen = (totalRows - numberOfRowsFromName(player.deviceName)) * screenResX;
                yOriginOfScreen = (numberOfColumnsFromName(player.deviceName)- 1) * screenResY;
            }
            console.log("totaleRows: ", totalRows);
            console.log("numberOfRowsFromName: ",numberOfRowsFromName(player.deviceName));
            console.log("xOriginOfScreen: ", xOriginOfScreen);
            console.log("yOriginOfScreen: ", yOriginOfScreen);
            var possiblyOnscreen = yOriginOfScreen <= scaledTickerY && yOriginOfScreen + screenResY > scaledTickerY;
            console.log("possiblyOnscreen: ",possiblyOnscreen);
            if(possiblyOnscreen){
                if(xOriginOfScreen + screenResX <= scaledTickerX){
                    console.log("ticker starts to the right of this screen");
                }else if (scaledTickerX + scaledTickerW < xOriginOfScreen){
                    console.log("ticker ends to the left of this screen");
                }else{
                    console.log("pushed to players with ticker onscreen list");
                    playersWithTickerOnScreen.push(player);
                    if($scope.playerDeviceInfo.monitororientation == "landscape"){
                        if(numberOfColumnsFromName(rightMostTicker) <= numberOfColumnsFromName(player.deviceName)){
                            rightMostTicker = player.deviceName;
                        }
                    }else{
                        if(numberOfRowsFromName(rightMostTicker) >= numberOfRowsFromName(player.deviceName)){
                            rightMostTicker = player.deviceName;
                        }
                    }

                    player.localTickerParams = {};
                    //ticker starts to the left of this screen
                    console.log("xOriginOfScreen: ",xOriginOfScreen,", scaledTickerX: ",scaledTickerX);
                    if($scope.playerDeviceInfo.monitororientation == "landscape"){
                        if(xOriginOfScreen > scaledTickerX){
                            player.localTickerParams.x = 0;
                            player.localTickerParams.offset = xOriginOfScreen - scaledTickerX + $scope.bezelXPixels;
                        }else{
                            //ticker's X origin starts on this screen
                            player.localTickerParams.x = scaledTickerX - xOriginOfScreen;
                            player.localTickerParams.offset = 0;
                        }
                        if(xOriginOfScreen + screenResX < scaledTickerX + scaledTickerW){
                            //ticker ends to the right of this screen
                            player.localTickerParams.w = screenResX - player.localTickerParams.x;
                        }else{
                            //ticker's rightmost pixel is on this screen
                            player.localTickerParams.w = scaledTickerW + scaledTickerX - xOriginOfScreen;
                        }
                        console.log("scaledTickerW: "+scaledTickerW);
                        console.log("scaledTickerX: "+scaledTickerX);
                        console.log("xOriginOfScreen: "+xOriginOfScreen);
                        console.log("playerTickerX: ", player.localTickerParams.x);
                        console.log("playerTickerY: ", player.localTickerParams.y);
                        console.log("localTickerParams.w: "+ (scaledTickerW + scaledTickerX - xOriginOfScreen));

                    //Portrait mode
                    }else{
                        //Portrait Mode ticker doesn't have the same origin as css transform
                        //The positive magnitude of the x axis actually goes to the left
                        // player.localTickerParams.offset = scaledTickerW - screenResX*(numberOfRowsFromName(player.deviceName) - 1);
                        var tickerXOriginOfScreen = (numberOfRowsFromName(player.deviceName) - 1) * screenResX;
                        console.log(scaledTickerW, scaledTickerW, scaledTickerW, tickerXOriginOfScreen);
                        player.localTickerParams.offset = scaledTickerW - (scaledTickerW - (scaledTickerW + scaledTickerX - tickerXOriginOfScreen));
                        /*
                        a-1
                        offset = scaledW
                        b-1
                        offset = scaledW - a1Width
                        offset = scaledW - (scaledW - b1Xorigin)
                        c-1
                        offset = scaledW - a1Width - b1Width

                        a1Width = scaledW - b1Width - c1Width
                        a1Width = scaledW - b1Xorigin
                        */


                        console.log("scaledTickerW: ", scaledTickerW);
                        //console.log(xOriginOfScreen," + ",screenResX," < (",scaledTickerX," + ",scaledTickerW,") - ",xOriginOfScreen);
                        if((xOriginOfScreen + screenResX) > (scaledTickerX + scaledTickerW)){
                            console.log("ticker ends on this screen");
                            console.log("xOriginOfScreen: ",xOriginOfScreen);
                            console.log("screenResX: ", screenResX);
                            player.localTickerParams.x =  ((totalRows)*screenResX - (scaledTickerX + scaledTickerW));
                        }else{
                            console.log("ticker ends to the right of this screen");
                            console.log("xOriginOfScreen: ",xOriginOfScreen);
                            console.log("screenResX: ", screenResX);
                            player.localTickerParams.x = 0;
                        }
                        if(xOriginOfScreen < scaledTickerX && xOriginOfScreen + screenResX > scaledTickerX){
                            console.log("ticker starts on this screen");
                            //var relativeX = scaledTickerX - xOriginOfScreen;
                            player.localTickerParams.w = screenResX - (scaledTickerX + player.localTickerParams.x - xOriginOfScreen);

                        }else{
                            console.log("ticker starts to the left of this screen");
                            player.localTickerParams.w = screenResX - player.localTickerParams.x;
                        }

                    }
                    console.log("player.localTickerParams.x: ",player.localTickerParams.x);
                    console.log("offset: ",player.localTickerParams.offset);
                    player.localTickerParams.y = scaledTickerY - yOriginOfScreen;
                    player.localTickerParams.h = scaledTickerH;
                    player.localTickerParams.scaledTickerWidth = scaledTickerW;
                }
            }else{
                console.log("Not on screen because: ");
                console.log("scaledTickerY: ",scaledTickerY);
                console.log("scaledTickerX: ",scaledTickerX);
                console.log("screenResX: ",screenResX);
                console.log("screenResY: ",screenResY);
            }
        }
        for(i = 0, len = playersWithTickerOnScreen.length; i < len; i++ ){
            player = playersWithTickerOnScreen[i];
            if(rightMostTicker == player.deviceName){
                player.localTickerParams.rightmost = true;
            }else{
                player.localTickerParams.rightmost = false;
            }
            sendTickerLayout(player);
        }
    }

    function sendTickerLayout(player){
        console.log("sendTickerLayout" +JSON.stringify(player.localTickerParams));
        $scope.sendUdpToIp(player.ipAddress, $scope.playerDeviceInfo.udpPort, JSON.stringify(player.localTickerParams));
    }

    $scope.initializeTicker = function(tickerParams){
        console.log("Initialize Ticker: ");
        console.log(tickerParams);
        $scope.globalTicker = {
            backgroundColor: tickerParams.backgroundColor,
            color:           tickerParams.color,
            speed:           tickerParams.speed,
            x:               tickerParams.x,
            y:               tickerParams.y,
            width:           tickerParams.width,
            height:          tickerParams.height,

            slavesHaveBeenAddedOrRemoved: false
        };
        console.log(parseInt(tickerParams.color));
        console.log(parseInt(tickerParams.backgroundColor));

        //$scope.newTicker(tickerParams.color, tickerParams.backgroundColor, tickerParams.speed, tickerParams.x, tickerParams.y, tickerParams.width, tickerParams.height);
        console.log("tickerObj: ");
        console.log($scope.ticker);
        var localTickerData = (localStorage.getItem("tickerFeed"));
        if(localTickerData){
            $scope.tickerFeed = JSON.parse(localTickerData);
        }
    };

    $scope.newTicker = function(color, backgroundColor, speed, x, y, width, height, rightmost, offset, scaledTickerWidth, rotated){
        if ($scope.ticker){
            $scope.ticker.Shutdown();
        }
        //$scope.ticker = new BSTickerProxy({id:"ticker",debug:true});
        console.log("ticker = new BSTickerProxy({id:\"ticker\",layout:{x:",x,",y:",y,",w:",width,",h:",height,",r:",(rotated?90:0),"},debug:true});");
        $scope.ticker = new BSTickerProxy({id:"ticker",layout:{x:x,y:y,w:width,h:height,r:(rotated?90:0)},debug:true});
        $scope.ticker.SetRightmost(rightmost);
        $scope.ticker.SetPixelsPerSecond(speed);

        $scope.ticker.SetMultiscreen(offset, scaledTickerWidth, "239.0.100.11", 5400);

        console.log("offset: ",offset);
        console.log("scaledTickerWidth: ",scaledTickerWidth);
        console.log(color);
        console.log(backgroundColor);
        $scope.ticker.SetForegroundColor(color);
        $scope.ticker.SetBackgroundColor(backgroundColor);
        if (rightmost) {
            //console.log("rightmost: "+ rightmost);
            //console.log("$scope.tickerFeed: " + $scope.tickerFeed);
            //console.log("$scope.tickerFeed.length: "+ $scope.tickerFeed.length);
            for(var i = 0; i < $scope.tickerFeed.length; i++){
                $scope.ticker.AddString($scope.tickerFeed[i]);
            }
        }
        console.log($scope.ticker);
    };

    //$scope.loadFromMemory();
    bsMessagePort.PostBSMessage({htmlready:true});
    $interval(networkErrorCheck, 5000);


    function otherMasterErrorCheck(){
        var udpJSON = {
            masterErrorCheck: $scope.playerDeviceInfo.ipaddress
        };
        $scope.doSendUdp(JSON.stringify(udpJSON));
    }

    function networkErrorCheck(){
        if (!$scope.playerDeviceInfo.ipaddress){
            console.log("Error: No network connection");
            $scope.addNoNetworkConnectionErrorMessage();
            if($scope.player){
                $scope.player.hidden = true;
            }
        }else{
            $scope.removeNoNetworkConnectionErrorMessage();
            if (!$scope.cannotConnectToMasterErrorMessage && !$scope.playerNameError) {
                if ($scope.player) {
                    $scope.player.hidden = false;
                }
            }
        }
    }

    function cannotContactMasterCheck(){
        if(Date.now() - $scope.playerDeviceInfo.lastMasterContact > 10000){
            $scope.addConnectToMasterErrorMessage();
            if($scope.player){
                $scope.player.hidden = true;
            }
        }else {
            $scope.removeConnectToMasterErrorMessage();
            if (!$scope.noNetworkConnectionErrorMessage && !$scope.playerNameError) {
                if ($scope.player) {
                    $scope.player.hidden = false;
                }
            }
        }
    }

    $scope.addLoadingMessage = function(){
        if(!$scope.loadingMessage) {
            $scope.loadingMessage = growl.info("Loading...");
        }
    };

    $scope.removeLoadingMessage = function(){
        if($scope.loadingMessage){
            $scope.loadingMessage.destroy();
            $scope.loadingMessage = 0;
        }
    };

    $scope.addConnectToMasterErrorMessage = function(){
        if(!$scope.cannotConnectToMasterErrorMessage) {
            $scope.cannotConnectToMasterErrorMessage = growl.error("Error: Cannot contact master");
        }
    };

    $scope.removeConnectToMasterErrorMessage = function(){
        if($scope.cannotConnectToMasterErrorMessage){
            $scope.cannotConnectToMasterErrorMessage.destroy();
            $scope.cannotConnectToMasterErrorMessage = 0;
        }
    };

    $scope.addNoNetworkConnectionErrorMessage = function(){
        if(!$scope.noNetworkConnectionErrorMessage) {
            $scope.noNetworkConnectionErrorMessage = growl.error("Error: No network connection");
        }
    };

    $scope.removeNoNetworkConnectionErrorMessage = function(){
        if($scope.noNetworkConnectionErrorMessage){
            $scope.noNetworkConnectionErrorMessage.destroy();
            $scope.noNetworkConnectionErrorMessage = 0;
        }
    };

    $scope.ptpConflictErrorMessage = function(){
            $scope.player.hidden = true;
            $scope.conflictMessage = growl.error("There are two players that are named 'A-1' on the network. Please change the ptp_domain user variable on one and reboot the video walls.");

    };

    function meetsRequiredNamingConvention(name) {
        var firstChar = name.charCodeAt(0);
        if(firstChar < 97 || firstChar > 122) {
            return false;
        }
        var secondChar = name.charCodeAt(1);
        if (secondChar != 45){
            return false;
        }
        var restOfString = name.substring(2, name.length);
        for (var i = 0; i < restOfString.length; i++){
            if(isNaN(restOfString[i])){
                return false;
            }
        }
        return true;
    }

    function addPlayerNameDoesNotMeetNamingConventionMessage(name) {
        if($scope.player){
            $scope.player.hidden = true;
        }
        $scope.playerNameError = growl.error("Error: Player name does not meet requirements");
    }
});

