'use strict';


// Creates UDP sender singleton
bsApp.factory('udpSocket',
    function (udpPort) {
        var sock = new BSDatagramSocket();
        //sock.BindLocalPort(udpPort);
        //console.log("sock=" + sock);
        return sock;
    }
);
bsApp.service('udpUtils',
    function () {
        // Converts received bytes to a string
        this.bytesToString = function (bytes) {
            //console.log("the bytes:" + bytes);
            var byteArray = new Int8Array(bytes);
            var udpMessage = String.fromCharCode.apply(null, byteArray);
            //console.log("udpMessage :" + udpMessage);
            return udpMessage;
        };
    }
);
bsApp.service('udpSender',
    function (udpSocket, udpDestination, udpPort) {
        this.send = function (message) {
            console.log('udpSender: ',udpSocket,' ',udpDestination,' ',udpPort);
            var result = udpSocket.SendTo(udpDestination, udpPort, message);
            console.log("SendTo result=" + result);
        };
        this.sendToIp = function(ip, port, message){
            var result = udpSocket.SendTo(ip, port, message);
            //console.log(result);
        };
        this.BindLocalPort = function(udpPort){
            //udpSocket = new BSDatagramSocket();
            var result = udpSocket.BindLocalPort(udpPort);
            console.log("Bind to port: ",udpPort," ",result);

        };
    }
);

//Creates BSMessagePort to Communicate with BrightScript Plugin
bsApp.factory('bsMessagePort',
    function(){
        var theMessagePort = new BSMessagePort();
        return theMessagePort;
    }
);